const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const comments = sequelize.define(
    'comments',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

content: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"visible",


"hidden",


"deleted",


"flagged"

        ],

      },

posted_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  comments.associate = (db) => {

    db.comments.belongsToMany(db.mentions, {
      as: 'mentions',
      foreignKey: {
        name: 'comments_mentionsId',
      },
      constraints: false,
      through: 'commentsMentionsMentions',
    });

    db.comments.belongsToMany(db.mentions, {
      as: 'mentions_filter',
      foreignKey: {
        name: 'comments_mentionsId',
      },
      constraints: false,
      through: 'commentsMentionsMentions',
    });


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity























    db.comments.hasMany(db.mentions, {
      as: 'mentions_comment',
      foreignKey: {
          name: 'commentId',
      },
      constraints: false,
    });



















//end loop



    db.comments.belongsTo(db.media_items, {
      as: 'media_item',
      foreignKey: {
        name: 'media_itemId',
      },
      constraints: false,
    });

    db.comments.belongsTo(db.users, {
      as: 'author',
      foreignKey: {
        name: 'authorId',
      },
      constraints: false,
    });

    db.comments.belongsTo(db.comments, {
      as: 'parent_comment',
      foreignKey: {
        name: 'parent_commentId',
      },
      constraints: false,
    });

    db.comments.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.comments.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.comments.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return comments;
};


